Index: /trunk/src/objects/RpHash.h.in
===================================================================
--- /trunk/src/objects/RpHash.h.in	(revision 1270)
+++ /trunk/src/objects/RpHash.h.in	(revision 1270)
@@ -0,0 +1,223 @@
+
+/*
+ * bltHash.h --
+ *
+ * Copyright 2001 Silicon Metrics Corporation.
+ *
+ * Permission to use, copy, modify, and distribute this software and
+ * its documentation for any purpose and without fee is hereby
+ * granted, provided that the above copyright notice appear in all
+ * copies and that both that the copyright notice and warranty
+ * disclaimer appear in supporting documentation, and that the names
+ * of Lucent Technologies any of their entities not be used in
+ * advertising or publicity pertaining to distribution of the software
+ * without specific, written prior permission.
+ *
+ * Silicon Metrics disclaims all warranties with regard to this
+ * software, including all implied warranties of merchantability and
+ * fitness.  In no event shall Lucent Technologies be liable for any
+ * special, indirect or consequential damages or any damages
+ * whatsoever resulting from loss of use, data or profits, whether in
+ * an action of contract, negligence or other tortuous action, arising
+ * out of or in connection with the use or performance of this
+ * software.
+ *
+ * Bob Jenkins, 1996.  hash.c.  Public Domain.
+ * Bob Jenkins, 1997.  lookup8.c.  Public Domain.
+ *
+ * Copyright (c) 1991-1993 The Regents of the University of California.
+ * Copyright (c) 1994 Sun Microsystems, Inc.
+ *
+ * See the file "license.terms" for information on usage and redistribution
+ * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+ *
+ * RCS: @(#) $Id: bltHash.h.in,v 1.5 2002/07/14 00:08:13 ghowlett Exp $
+ */
+
+#ifndef RP_HASH_H
+#define RP_HASH_H 1
+
+#ifndef RP_INT_H
+#ifndef SIZEOF_LONG
+#define SIZEOF_LONG @SIZEOF_LONG@
+#endif
+#ifndef SIZEOF_LONG_LONG
+#define SIZEOF_LONG_LONG @SIZEOF_LONG_LONG@
+#endif
+#ifndef SIZEOF_INT
+#define SIZEOF_INT @SIZEOF_INT@
+#endif
+#ifndef SIZEOF_VOID_P
+#define SIZEOF_VOID_P @SIZEOF_VOID_P@
+#endif
+#ifndef HAVE_INTTYPES_H
+#if @HAVE_INTTYPES_H@
+#define HAVE_INTTYPES_H 1
+#endif
+#endif
+#endif /* !RP_INT_H */
+
+#ifdef HAVE_INTTYPES_H
+#include <inttypes.h>
+#else
+#if (SIZEOF_VOID_P == 8)
+#if (SIZEOF_LONG == 8)
+typedef signed long int64_t;
+typedef unsigned long uint64_t;
+#else
+typedef signed long long int64_t;
+typedef unsigned long long uint64_t;
+#endif /* SIZEOF_LONG == 8 */
+#else
+#ifndef __CYGWIN__
+typedef signed int int32_t;
+#endif /* __CYGWIN__ */
+typedef unsigned int uint32_t;
+#endif /* SIZEOF_VOID_P == 8 */
+#endif /* HAVE_INTTYPES_H */
+
+#if (SIZEOF_VOID_P == 8)
+typedef uint64_t Rp_Hash;
+#else
+typedef uint32_t Rp_Hash;
+#endif /* SIZEOF_VOID_P == 8 */
+
+#include "RpPool.h"
+
+/*
+ * Acceptable key types for hash tables:
+ */
+#define RP_STRING_KEYS      0
+#define RP_ONE_WORD_KEYS    ((size_t)-1)
+
+/*
+ * Forward declaration of Rp_HashTable.  Needed by some C++ compilers
+ * to prevent errors when the forward reference to Rp_HashTable is
+ * encountered in the Rp_HashEntry structure.
+ */
+
+#ifdef __cplusplus
+struct Rp_HashTable;
+#endif
+
+typedef union {             /* Key has one of these forms: */
+    void *oneWordValue;     /* One-word value for key. */
+    unsigned long words[1]; /* Multiple integer words for key.
+                             * The actual size will be as large
+                             * as necessary for this table's
+                             * keys. */
+    char string[4];         /* string for key.  The actual size
+                             * will be as large as needed to hold
+                             * the key. */
+} Rp_HashKey;
+
+/*
+ * Structure definition for an entry in a hash table.  No-one outside
+ * Rp should access any of these fields directly;  use the macros
+ * defined below.
+ */
+typedef struct Rp_HashEntry {
+    struct Rp_HashEntry *nextPtr;   /* Pointer to next entry in this
+                                     * hash bucket, or NULL for end of
+                                     * chain. */
+    Rp_Hash hval;
+
+    ClientData clientData;          /* Application stores something here
+                                     * with Rp_SetHashValue. */
+    Rp_HashKey key;                 /* MUST BE LAST FIELD IN RECORD!! */
+} Rp_HashEntry;
+
+/*
+ * Structure definition for a hash table.  Must be in blt.h so clients
+ * can allocate space for these structures, but clients should never
+ * access any fields in this structure.
+ */
+#define RP_SMALL_HASH_TABLE 4
+typedef struct Rp_HashTable {
+    Rp_HashEntry **buckets;         /* Pointer to bucket array.  Each
+                                     * element points to first entry in
+                                     * bucket's hash chain, or NULL. */
+    Rp_HashEntry *staticBuckets[RP_SMALL_HASH_TABLE];
+                                    /* Bucket array used for small tables
+                                     * (to avoid mallocs and frees). */
+    size_t numBuckets;              /* Total number of buckets allocated
+                                     * at **buckets. */
+    size_t numEntries;              /* Total number of entries present
+                                     * in table. */
+    size_t rebuildSize;             /* Enlarge table when numEntries gets
+                                     * to be this large. */
+    Rp_Hash mask;                   /* Mask value used in hashing
+                                     * function. */
+    unsigned int downShift;         /* Shift count used in hashing
+                                     * function.  Designed to use high
+                                     * order bits of randomized keys. */
+    size_t keyType;                 /* Type of keys used in this table.
+                                     * It's either RP_STRING_KEYS,
+                                     * RP_ONE_WORD_KEYS, or an integer
+                                     * giving the number of ints that
+                                     * is the size of the key.
+                                     */
+    Rp_HashEntry *(*findProc) _ANSI_ARGS_((struct Rp_HashTable *tablePtr,
+        CONST void *key));
+    Rp_HashEntry *(*createProc) _ANSI_ARGS_((struct Rp_HashTable *tablePtr,
+        CONST void *key, int *newPtr));
+
+    Rp_Pool hPool;      /* Pointer to the pool allocator used
+                         * for entries in this hash table. If
+                         * NULL, the standard Tcl_Alloc,
+                         * Tcl_Free routines will be used
+                         * instead.
+                         */
+} Rp_HashTable;
+
+/*
+ * Structure definition for information used to keep track of searches
+ * through hash tables:
+ */
+
+typedef struct {
+    Rp_HashTable *tablePtr;         /* Table being searched. */
+    unsigned long nextIndex;        /* Index of next bucket to be
+                                     * enumerated after present one. */
+    Rp_HashEntry *nextEntryPtr;     /* Next entry to be enumerated in the
+                                     * the current bucket. */
+} Rp_HashSearch;
+
+/*
+ * Macros for clients to use to access fields of hash entries:
+ */
+
+#define Rp_GetHashValue(h) ((h)->clientData)
+#define Rp_SetHashValue(h, value) ((h)->clientData = (ClientData)(value))
+#define Rp_GetHashKey(tablePtr, h) \
+    ((void *) (((tablePtr)->keyType == RP_ONE_WORD_KEYS) ? \
+     (void *)(h)->key.oneWordValue : (h)->key.string))
+
+/*
+ * Macros to use for clients to use to invoke find and create procedures
+ * for hash tables:
+ */
+#define Rp_FindHashEntry(tablePtr, key) \
+    (*((tablePtr)->findProc))(tablePtr, key)
+#define Rp_CreateHashEntry(tablePtr, key, newPtr) \
+    (*((tablePtr)->createProc))(tablePtr, key, newPtr)
+
+EXTERN void Rp_InitHashTable _ANSI_ARGS_((Rp_HashTable *tablePtr,
+    size_t keyType));
+
+EXTERN void Rp_InitHashTableWithPool _ANSI_ARGS_((Rp_HashTable *tablePtr,
+    size_t keyType));
+
+EXTERN void Rp_DeleteHashTable _ANSI_ARGS_((Rp_HashTable *tablePtr));
+
+EXTERN void Rp_DeleteHashEntry _ANSI_ARGS_((Rp_HashTable *tablePtr,
+    Rp_HashEntry *entryPtr));
+
+EXTERN Rp_HashEntry *Rp_FirstHashEntry _ANSI_ARGS_((Rp_HashTable *tablePtr,
+    Rp_HashSearch *searchPtr));
+
+EXTERN Rp_HashEntry *Rp_NextHashEntry _ANSI_ARGS_((Rp_HashSearch *srchPtr));
+
+EXTERN char *Rp_HashStats _ANSI_ARGS_((Rp_HashTable *tablePtr));
+
+#endif /* RP_HASH_H */
Index: /trunk/src/objects/RpHashHelper.c
===================================================================
--- /trunk/src/objects/RpHashHelper.c	(revision 1270)
+++ /trunk/src/objects/RpHashHelper.c	(revision 1270)
@@ -0,0 +1,255 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <ctype.h>
+#include "RpHashHelper.h"
+
+int
+Rp_HashPrint(
+    Rp_HashTable *h)
+{
+    Rp_HashEntry *hEntry = NULL;
+    Rp_HashSearch hSearch;
+    char *k = NULL;
+    char *v = NULL;
+
+    printf("hash table start\n");
+    hEntry = Rp_FirstHashEntry(h,&hSearch);
+    while (hEntry != NULL) {
+        k = (char *) Rp_GetHashKey(h,hEntry);
+        v = (char *) Rp_GetHashValue(hEntry);
+        printf("hentry = :%s->%s:\n",k,v);
+        hEntry = Rp_NextHashEntry(&hSearch);
+    }
+    printf("hash table end\n");
+    return 0;
+}
+
+int
+Rp_HashAddNode(
+    Rp_HashTable *h,
+    const char* key,
+    const void *n)
+{
+    int isNew = 0;
+    Rp_HashEntry *hEntry = NULL;
+
+    hEntry = Rp_CreateHashEntry(h,key,&isNew);
+    if (isNew == 0) {
+        // hash entry is not new
+        // warn user: two vals with the same name
+        // warn("hash entry is not new\n");
+    }
+    Rp_SetHashValue(hEntry,(ClientData)n);
+    return isNew;
+}
+
+/*
+ *  hRslt = h1 U h2
+ */
+
+int
+Rp_HashUnion(
+    Rp_HashTable *hRslt,
+    Rp_HashTable *h1,
+    Rp_HashTable *h2,
+    int (*cpyFxn)(void **to, void *from),
+    int (*cmpFxn) (void *he1, void *he2))
+{
+    Rp_HashSearch hSearch;
+    Rp_HashEntry *hEntry = NULL;
+    void *origKey = NULL;
+    void *origNode = NULL;
+    void *newNode = NULL;
+    void *searchRslt = NULL;
+    int nodesAddedCnt = 0;
+
+    Rp_HashCopy(hRslt,h1,cpyFxn);
+
+    hEntry = Rp_FirstHashEntry(h2,&hSearch);
+    while (hEntry != NULL) {
+        origKey = Rp_GetHashKey(h2,hEntry);
+        origNode = Rp_GetHashValue(hEntry);
+        searchRslt = Rp_HashSearchNode(hRslt,origKey);
+        if (searchRslt == NULL) {
+            // node not in hRslt, add it
+            cpyFxn(&newNode,origNode);
+            Rp_HashAddNode(hRslt,origKey,newNode);
+            nodesAddedCnt++;
+        }
+        hEntry = Rp_NextHashEntry(&hSearch);
+    }
+    return nodesAddedCnt;
+}
+
+/*
+ *  hRslt = h1 - h2
+ */
+
+int
+Rp_HashSubrtact(
+    Rp_HashTable *hRslt,
+    Rp_HashTable *h1,
+    Rp_HashTable *h2,
+    int (*cpyFxn)(void **to, void *from),
+    int (*cmpFxn)(void *he1, void *he2))
+{
+    Rp_HashSearch hSearch;
+    Rp_HashEntry *hEntry = NULL;
+    void *origKey = NULL;
+    void *origNode = NULL;
+    void *newNode = NULL;
+    int nodesAddedCnt = 0;
+
+    hEntry = Rp_FirstHashEntry(h1,&hSearch);
+    while (hEntry != NULL) {
+        origKey = Rp_GetHashKey(h1,hEntry);
+        origNode = Rp_GetHashValue(hEntry);
+        if (Rp_HashSearchNode(h2,origKey) == NULL) {
+            // node not in h2, add it to hRslt
+            cpyFxn(&newNode,origNode);
+            Rp_HashAddNode(hRslt,origKey,newNode);
+            nodesAddedCnt++;
+        }
+        hEntry = Rp_NextHashEntry(&hSearch);
+    }
+    return nodesAddedCnt;
+}
+
+int
+Rp_HashCompare(
+    Rp_HashTable *h1,
+    Rp_HashTable *h2,
+    int (*cmpFxn)(void *n1,void *n2))
+{
+    Rp_HashSearch hSearch;
+    Rp_HashEntry *h1Entry = NULL;
+    Rp_HashEntry *h2Entry = NULL;
+    void *h1Node = NULL;
+    void *h2Key = NULL;
+    void *h2Node = NULL;
+    int compareResult = 0;
+
+    // check the pointer values
+    if ( (h1 == NULL) && (h2 != NULL) ) {
+        return -1;
+    } else if ( (h1 != NULL) && (h2 == NULL) ) {
+        return 1;
+    } else if (h1 == h2) {
+        return 0;
+    }
+
+    // check hash table sizes
+    if (h1->numEntries < h2->numEntries) {
+        return -1;
+    } else if (h1 ->numEntries > h2->numEntries) {
+        return 1;
+    }
+
+    // equal number of entries, have to check each entry.
+
+    h2Entry = Rp_FirstHashEntry(h2,&hSearch);
+    while (h2Entry != NULL) {
+        h2Key = Rp_GetHashKey(h2,h2Entry);
+        h2Node = Rp_GetHashValue(h2Entry);
+        h1Entry = Rp_FindHashEntry(h1,h2Key);
+        if (h1Entry == NULL) {
+            compareResult = -1;
+            break;
+        } else {
+            h1Node = Rp_GetHashValue(h1Entry);
+            compareResult = cmpFxn(h1Node,h2Node);
+            if (compareResult != 0) {
+                break;
+            }
+        }
+        h2Entry = Rp_NextHashEntry(&hSearch);
+    }
+    return compareResult;
+}
+
+
+/*
+ *  forall(i) h1(i) = h2(i) : i E (nodes(h2))
+ *  elements of h2 are copied to h1 regardless of if h1
+ *  already has elements in it.
+ */
+
+int
+Rp_HashCopy(
+    Rp_HashTable *h1,
+    Rp_HashTable *h2,
+    int (*cpyFxn)(void **to,void *from))
+{
+    Rp_HashSearch hSearch;
+    Rp_HashEntry *hEntry = NULL;
+    void *origKey = NULL;
+    void *origNode = NULL;
+    void *newNode = NULL;
+
+    hEntry = Rp_FirstHashEntry(h2,&hSearch);
+    while (hEntry != NULL) {
+        origKey = Rp_GetHashKey(h2,hEntry);
+        origNode = Rp_GetHashValue(hEntry);
+        if (cpyFxn(&newNode,origNode) != 0) {
+            // error while copying
+        }
+        Rp_HashAddNode(h1,origKey,newNode);
+        hEntry = Rp_NextHashEntry(&hSearch);
+    }
+    return 0;
+}
+
+/*
+ * this function will not work for you if you put
+ * entries in the hash table with null data value
+ */
+
+void *
+Rp_HashSearchNode(
+    Rp_HashTable *h,
+    const char *key)
+{
+    Rp_HashEntry *hEntry = NULL;
+    void *n = NULL;
+    hEntry = Rp_FindHashEntry(h,key);
+    if (hEntry != NULL) {
+        n = Rp_GetHashValue(hEntry);
+    }
+    return n;
+}
+
+void *
+Rp_HashRemoveNode(
+    Rp_HashTable *h,
+    const char *key)
+{
+    Rp_HashEntry *hEntry = NULL;
+    void *n = NULL;
+    hEntry = Rp_FindHashEntry(h,key);
+    if (hEntry != NULL) {
+        n = Rp_GetHashValue(hEntry);
+        Rp_DeleteHashEntry(h,hEntry);
+    }
+    return n;
+}
+
+int charCpyFxn(
+    void **to,
+    void *from)
+{
+    size_t len = 0;
+
+    len = strlen((char*)from);
+    *to = (void*) malloc(len*sizeof(char));
+    strcpy((char*)(*to),(char*)from);
+    return 0;
+}
+
+int charCmpFxn(
+    void *to,
+    void *from)
+{
+    return strcmp(to,from);
+}
+
Index: /trunk/src/objects/RpHashHelper.h
===================================================================
--- /trunk/src/objects/RpHashHelper.h	(revision 1270)
+++ /trunk/src/objects/RpHashHelper.h	(revision 1270)
@@ -0,0 +1,38 @@
+#ifndef _RP_HASH_HELPER_H
+#define _RP_HASH_HELPER_H 1
+
+#include "RpInt.h"
+#include "RpHash.h"
+
+int Rp_HashPrint        ( Rp_HashTable *h);
+
+int Rp_HashAddNode      ( Rp_HashTable *h, const char *key, const void *n);
+
+int Rp_HashUnion        ( Rp_HashTable *hRslt,
+                          Rp_HashTable *h1,
+                          Rp_HashTable *h2,
+                          int (*cpyFxn)(void **to, void *from),
+                          int (*cmpFxn) (void *he1, void *he2));
+
+int Rp_HashSubrtact     ( Rp_HashTable *hRslt,
+                          Rp_HashTable *h1,
+                          Rp_HashTable *h2,
+                          int (*cpyFxn)(void **to, void *from),
+                          int (*cmpFxn)(void *he1, void *he2));
+
+int Rp_HashCompare      ( Rp_HashTable *h1,
+                          Rp_HashTable *h2,
+                          int (*cmpFxn)(void *n1,void *n2));
+
+int Rp_HashCopy         ( Rp_HashTable *h1,
+                          Rp_HashTable *h2,
+                          int (*cpyFxn)(void **to,void *from));
+
+void *Rp_HashSearchNode ( Rp_HashTable *h, const char *key);
+
+void *Rp_HashRemoveNode ( Rp_HashTable *h, const char *key);
+
+int charCpyFxn(void **to, void *from);
+int charCmpFxn( void *to, void *from);
+
+#endif // _RP_HASH_HELPER_H
Index: /trunk/src/objects/RpInt.h
===================================================================
--- /trunk/src/objects/RpInt.h	(revision 1270)
+++ /trunk/src/objects/RpInt.h	(revision 1270)
@@ -0,0 +1,297 @@
+
+/*
+ * bltInt.h --
+ *
+ * Copyright 1993-1998 Lucent Technologies, Inc.
+ *
+ * Permission to use, copy, modify, and distribute this software and
+ * its documentation for any purpose and without fee is hereby
+ * granted, provided that the above copyright notice appear in all
+ * copies and that both that the copyright notice and warranty
+ * disclaimer appear in supporting documentation, and that the names
+ * of Lucent Technologies any of their entities not be used in
+ * advertising or publicity pertaining to distribution of the software
+ * without specific, written prior permission.
+ *
+ * Lucent Technologies disclaims all warranties with regard to this
+ * software, including all implied warranties of merchantability and
+ * fitness.  In no event shall Lucent Technologies be liable for any
+ * special, indirect or consequential damages or any damages
+ * whatsoever resulting from loss of use, data or profits, whether in
+ * an action of contract, negligence or other tortuous action, arising
+ * out of or in connection with the use or performance of this
+ * software.
+ */
+
+#ifndef _RP_INT_H
+#define _RP_INT_H
+
+// #define USE_NON_CONST
+
+#include <stdio.h>
+#include <assert.h>
+
+#include <stdlib.h>
+#include <string.h>
+#include <errno.h>
+#include <ctype.h>
+#include <memory.h>
+#include <unistd.h>
+#include <limits.h>
+
+// keep this commented until i fix the autoheader setup to
+// automatically #define these
+//
+// #include "bltConfig.h"
+//#ifdef HAVE_STDLIB_H
+//#include <stdlib.h>
+//#endif /* HAVE_STDLIB_H */
+//
+//#ifdef HAVE_STRING_H
+//#include <string.h>
+//#endif /* HAVE_STRING_H */
+//
+//#ifdef HAVE_ERRNO_H
+//#include <errno.h>
+//#endif /* HAVE_ERRNO_H */
+//
+//#ifdef HAVE_CTYPE_H
+//#include <ctype.h>
+//#endif /* HAVE_CTYPE_H */
+//
+//#ifdef HAVE_MEMORY_H
+//#include <memory.h>
+//#endif /* HAVE_MEMORY_H */
+//
+//#ifdef HAVE_UNISTD_H
+//#include <unistd.h>
+//#endif /* HAVE_UNISTD_H */
+//
+//#ifdef HAVE_LIMITS_H
+//#include <limits.h>
+//#endif
+
+#define RP_OK       0
+#define RP_ERROR    1
+#define RP_RETURN   2
+#define RP_BREAK    3
+#define RP_CONTINUE 4
+
+#ifndef _CLIENTDATA
+#   ifndef NO_VOID
+    typedef void *ClientData;
+#   else
+    typedef int *ClientData;
+#   endif
+#   define _CLIENTDATA
+
+#ifndef NO_CONST
+#   define CONST const
+#else
+#   define CONST
+#endif
+
+/*
+#ifndef _ANSI_ARGS_
+#   define _ANSI_ARGS_(x)       ()
+#endif
+*/
+
+#ifndef _ANSI_ARGS_
+#if defined(__STDC__) || defined(__cplusplus)
+#   define _ANSI_ARGS_(x)       x
+#else
+#   define _ANSI_ARGS_(x)       ()
+#endif
+#endif
+
+
+#endif
+#undef INLINE
+#ifdef __GNUC__
+#define INLINE inline
+#else
+#define INLINE
+#endif
+// #undef EXPORT
+// #define EXPORT
+
+#ifndef EXPORT
+#define EXPORT
+#endif
+
+#undef EXTERN
+
+#ifdef __cplusplus
+#   define EXTERN extern "C" EXPORT
+#else
+#   define EXTERN extern EXPORT
+#endif
+
+
+#undef VARARGS
+#ifdef __cplusplus
+#define ANYARGS (...)
+#define VARARGS(first)  (first, ...)
+#define VARARGS2(first, second)  (first, second, ...)
+#else
+#define ANYARGS ()
+#define VARARGS(first) ()
+#define VARARGS2(first, second) ()
+#endif /* __cplusplus */
+
+#undef MIN
+#define MIN(a,b)    (((a)<(b))?(a):(b))
+
+#undef MAX
+#define MAX(a,b)    (((a)>(b))?(a):(b))
+
+#undef MIN3
+#define MIN3(a,b,c) (((a)<(b))?(((a)<(c))?(a):(c)):(((b)<(c))?(b):(c)))
+
+#undef MAX3
+#define MAX3(a,b,c) (((a)>(b))?(((a)>(c))?(a):(c)):(((b)>(c))?(b):(c)))
+
+#define TRUE    1
+#define FALSE   0
+
+/*
+ * The macro below is used to modify a "char" value (e.g. by casting
+ * it to an unsigned character) so that it can be used safely with
+ * macros such as isspace.
+ */
+#define UCHAR(c) ((unsigned char) (c))
+
+#undef panic
+#define panic(mesg) Rp_Panic("%s:%d %s", __FILE__, __LINE__, (mesg))
+
+/*
+ * Since the Tcl/Tk distribution doesn't perform any asserts, dynamic
+ * loading can fail to find the __assert function.  As a workaround,
+ * we'll include our own.
+ */
+#undef  assert
+#ifdef  NDEBUG
+    #define assert(EX) ((void)0)
+#else
+    extern void Rp_Assert _ANSI_ARGS_((char *expr, char *file, int line));
+    #ifdef __STDC__
+        #define assert(EX) (void)((EX) || (Rp_Assert(#EX, __FILE__, __LINE__), 0))
+    #else
+        #define assert(EX) (void)((EX) || (Rp_Assert("EX", __FILE__, __LINE__), 0))
+    #endif /* __STDC__ */
+
+#endif /* NDEBUG */
+
+/*
+ * ----------------------------------------------------------------------
+ *
+ *  Assume we need to declare free if there's no stdlib.h or malloc.h
+ *
+ * ----------------------------------------------------------------------
+ */
+#if !defined(HAVE_STDLIB_H) && !defined(HAVE_MALLOC_H)
+extern void free _ANSI_ARGS_((void *));
+#endif
+
+extern int Rp_DictionaryCompare _ANSI_ARGS_((char *s1, char *s2));
+
+extern void Rp_Panic _ANSI_ARGS_((const char *format, ...));
+
+
+/* ---------------------------------------------------------------- */
+
+typedef int (QSortCompareProc) _ANSI_ARGS_((const void *, const void *));
+
+/*
+ * -------------------------------------------------------------------
+ *
+ * Point2D --
+ *
+ *	2-D coordinate.
+ *
+ * -------------------------------------------------------------------
+ */
+typedef struct {
+    double x, y;
+} Point2D;
+
+/*
+ * -------------------------------------------------------------------
+ *
+ * Point3D --
+ *
+ *	3-D coordinate.
+ *
+ * -------------------------------------------------------------------
+ */
+typedef struct {
+    double x, y, z;
+} Point3D;
+
+/*
+ * -------------------------------------------------------------------
+ *
+ * Segment2D --
+ *
+ *	2-D line segment.
+ *
+ * -------------------------------------------------------------------
+ */
+typedef struct {
+    Point2D p, q;		/* The two end points of the segment. */
+} Segment2D;
+
+/*
+ * -------------------------------------------------------------------
+ *
+ * Dim2D --
+ *
+ *	2-D dimension.
+ *
+ * -------------------------------------------------------------------
+ */
+typedef struct {
+    short int width, height;
+} Dim2D;
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Region2D --
+ *
+ *      2-D region.  Used to copy parts of images.
+ *
+ *----------------------------------------------------------------------
+ */
+typedef struct {
+    int left, right, top, bottom;
+} Region2D;
+
+#define RegionWidth(r)      ((r)->right - (r)->left + 1)
+#define RegionHeight(r)     ((r)->bottom - (r)->top + 1)
+
+typedef struct {
+    double left, right, top, bottom;
+} Extents2D;
+
+typedef struct {
+    double left, right, top, bottom, front, back;
+} Extents3D;
+
+#define PointInRegion(e,x,y) \
+    (((x) <= (e)->right) && ((x) >= (e)->left) && \
+     ((y) <= (e)->bottom) && ((y) >= (e)->top))
+
+#define PointInRectangle(r,x0,y0) \
+    (((x0) <= (int)((r)->x + (r)->width - 1)) && ((x0) >= (int)(r)->x) && \
+     ((y0) <= (int)((r)->y + (r)->height - 1)) && ((y0) >= (int)(r)->y))
+
+
+#define Rp_Malloc malloc
+#define Rp_Calloc calloc
+#define Rp_Realloc realloc
+#define Rp_Free free
+#define Rp_Strdup strdup
+
+#endif /*_RP_INT_H*/
